'use client';

import { getErrorMessage } from '@/app/_util/errors';
import type { LinkedAccount } from '@/app/api/lincs/types';
import { add, fromUnixTime, isBefore, secondsToMilliseconds } from 'date-fns';
import type { JWT } from 'next-auth/jwt';
import queryString from 'query-string';
import randomstring from 'randomstring';
import type { SiteBroadcastChannel } from '../_types';
import { useBroadcastChannel } from './useBroadcastChannel';

const TOKEN_EXPIRES_IN = 5; // minutes

/**
 * The `useLinkedAccounts` function provides a set of utility functions for managing linked accounts,
 * including retrieving access tokens, refreshing tokens, and linking accounts with external identity providers.
 * @returns The `useLinkedAccounts` function returns an object with a set of utility functions for managing linked accounts
 */
export const useLinkedAccounts = () => {
  const { openAuxWindowChannel } = useBroadcastChannel();

  /**
   * The function `_loadJWT` fetches a JWT from the server and returns it if the response is successful.
   * @returns a Promise that resolves to a JWT object.
   */
  const _loadJWT = async () => {
    const response = await fetch('api/auth/jwt');
    if (response.status >= 400) return;

    const jwt: JWT = await response.json();
    return jwt;
  };

  /**
   * The function `getAccessToken` retrieves the access token from a linked account provider.
   * @param {string} providerId - The `providerId` parameter is a string that represents the ID of a provider.
   * @returns The access token from the provider's token object.
   */
  const getAccessToken = async (providerId: string) => {
    const provider = await getLinkedAccount(providerId);
    if (!provider) return;
    if (!provider.token) return;

    return provider.token.access_token;
  };

  /**
   * The function `getLinkedAccount` retrieves a linked account based on the provided provider ID.
   * @param {string} providerId - A string representing the identity provider ID.
   * @returns The function `getLinkedAccount` returns the provider object that matches the given `providerId`
   */
  const getLinkedAccount = async (providerId: string) => {
    const linkedAccounts = await getLinkedAccounts();
    if (!linkedAccounts) return;

    const provider = linkedAccounts.find((account) => account.identityProvider === providerId);
    return provider;
  };

  /**
   * The function `getLinkedAccounts` retrieves the linked accounts from a JSON Web Token (JWT) if it exists.
   * @returns Returns an array with the user's `linkedAccounts`.
   */
  const getLinkedAccounts = async () => {
    const jwt = await _loadJWT();
    if (!jwt) return;

    const linkedAccounts = jwt.linkedAccounts;
    return linkedAccounts;
  };

  /**
   * The function `getLinkedAccountUrl` is an asynchronous function that takes in a provider, a boolean
   * flag indicating whether it is a refresh, and a code verifier, and returns a promise that resolves to
   * the url to link the user account to a indentity providers.
   * @param {string} provider - The provider parameter is a string that represents the identity provider
   * for which you want to get the linked account URL. It could be a specific provider like "Google" or
   * "Facebook", or it could be a custom provider name.
   * @param [isRefresh=false] - The `isRefresh` parameter is a boolean value that indicates whether the
   * request is for refreshing an existing linked account. If `isRefresh` is `true`, it means that the
   * request is for refreshing the linked account, otherwise it is `false`.
   * @param {string} codeVerifier - The `codeVerifier` parameter is a string that represents a code
   * verifier used in the OAuth 2.0 authorization flow. It is typically generated by the client and used
   * to verify the authenticity of the authorization code received from the authorization server.
   * @returns a Promise that resolves to an object of type `GetLinkedAccountUrl`.
   */
  const getLinkedAccountUrl = async (provider: string, isRefresh = false, codeVerifier: string) => {
    const url = queryString.stringifyUrl({
      url: '/api/lincs/link-identity-provider-url',
      query: { provider, isRefresh, codeVerifier },
    });

    const response = await fetch(url);
    const data = await response.json();

    if (data.error) {
      console.warn(data.error);
      return { error: getErrorMessage(data.error) };
    }

    return data as { url: string };
  };

  /**
   * The function `isIDPTokenExpired` checks if a provider's access token has expired.
   * @param {string | LinkedAccount} provider - The `provider` parameter can be either a string or a
   * `LinkedAccount` object. If it is a string, it represents the ID of a linked account. If it is a
   * `LinkedAccount` object, it contains information about the linked account, including the access token
   * expiration time.
   * @returns a boolean value indicating whether the IDP token is expired or not.
   */
  const isIDPTokenExpired = async (provider: string | LinkedAccount) => {
    if (typeof provider === 'string') {
      const _provider = await getLinkedAccount(provider);
      if (!_provider) return false;
      provider = _provider;
    }

    const accessTokenExpiration = provider.token?.accessTokenExpiration;
    if (!accessTokenExpiration) return false;

    const willExpiredIn = add(new Date(), { minutes: TOKEN_EXPIRES_IN });
    const isExpired = isBefore(fromUnixTime(accessTokenExpiration), willExpiredIn);

    return isExpired;
  };

  /**
   * The `linkAccount` function is used to link a user account with a an external identity provider, such as github
   * or gitlab, by generating a codeVerifier and opening an auxiliary window to complete the linking process.
   * @param {string} providerId - The `providerId` parameter is a string that represents the ID of the
   * provider for which the account is being linked.
   * @param options - The `options` parameter is an optional object that can contain the following
   * property:
   *  --  isRefreshed {boolean} - if the call has been made to refresh the identity provider tokens.
   * @returns The function `openAuxWindowChannel` returns a Promise that resolves to a value of type `T`.
   * @returns The function `linkAccount` returns a promise that resolves to an object with properties
   * `success`, `error`, and `codeVerifier`.
   */
  const linkAccount = async (
    providerId: string,
    options: { isRefresh?: boolean } = { isRefresh: false },
  ) => {
    const { isRefresh } = options;

    const codeVerifier = randomstring.generate();
    const response = await getLinkedAccountUrl(providerId, isRefresh, codeVerifier);
    if ('error' in response) return { success: false, message: response.error };

    const message = await openAuxWindowChannel<SiteBroadcastChannel.LinkAccountMessage>(
      'keycloak-link-account',
      response.url,
      { timeout: secondsToMilliseconds(30) },
    ).catch((error: string) => {
      return { success: false, error: error } as SiteBroadcastChannel.LinkAccountMessage;
    });

    if (codeVerifier !== message.codeVerifier) {
      return {
        success: false,
        error: 'error: codeVerifier invalid',
      } as SiteBroadcastChannel.LinkAccountMessage;
    }

    return message;
  };

  /**
   * The function `refreshAllTokens` refreshes tokens for all linked accounts and returns a response
   * indicating the success and validity of each token.
   * @returns The function `refreshAllTokens` returns a Promise that resolves to an array of objects
   * contauner the `providerId`, if the token is valid and if it was refreshed, and an optional message.
   */
  const refreshAllTokens = async () => {
    const linkedAccounts = await getLinkedAccounts();
    if (!linkedAccounts) return;

    const response = [];

    for (const account of linkedAccounts) {
      const isExpired = await isIDPTokenExpired(account);
      if (!isExpired) {
        response.push({ provider: account.identityProvider, tokenValid: true });
        return;
      }

      const refreshedToken = await refreshToken(account.identityProvider);
      response.push({
        provider: account.identityProvider,
        tokenValid: refreshedToken.success,
        refreshed: refreshedToken.success,
        message: refreshedToken.message,
      });
    }

    return response;
  };

  //* ALIAS: linkAccount
  /**
   * The function `refreshToken` is an asynchronous function that takes a `providerId` as a parameter and
   * returns the result of calling the `linkAccount` function with the `isRefresh` option set to true.
   * @alias linkAccount
   * @param {string} providerId - The `providerId` parameter is a string that represents the ID of the
   * provider for which the account needs to be refreshed.
   * @returns The `refreshToken` function is returning the result of the `linkAccount` function with
   * the `isRefresh` parameter set to `true`.
   */
  const refreshToken = async (providerId: string) => {
    return await linkAccount(providerId, { isRefresh: true });
  };

  return {
    getAccessToken,
    getLinkedAccount,
    getLinkedAccounts,
    isIDPTokenExpired,
    linkAccount,
    refreshToken,
    refreshAllTokens,
  };
};
